#define PRECISION 100
#include "exfloat.h"
#include <iostream>
#include <iomanip>
using namespace std;

#include "exfutil.h"

void memory_dump(unsigned char *c)
{
  for(int i = 7; i >= 0; i--)
    printf("%02x:", c[i]);
  putchar('\n');

  return;
}

int main()
{
#if 0
    exfloat x = 0;
    cout << x << endl;

    if(x)
	cout << "x is not zero." << endl;

    x <<= 1;
    cout << x << endl;
    if(x)
	cout << "x is not zero." << endl;

    x = 1;
    cout << x << endl;
    x <<= 1;
    cout << x << endl;

    x = -1;
    cout << x << endl;
    x <<= 1;
    cout << x << endl;

    x = 64;
    cout << setprecision(20) << sin(x) << endl;
    cout << hex << sin(x) << endl;

    x = -250;
    cout << setiosflags(ios::fixed) << exp(x) << endl;
    cout << setiosflags(ios::scientific) << exp(x) << endl;

    x = "#PI";
    cout << setprecision(50) << x << endl;

    exfloat PI = "#PI";
    x = "3.2";
    cout << "hoge" << endl;
    cout << x << endl;
    cout << sinh(x) <<endl;
    cout << PI/2*sinh(x) << endl;
    cout <<tanh(PI/2*sinh(x)) << endl;
    cout << setprecision(50) << 1-tanh(PI/2*sinh(x)) << endl;

    double d = 0.1;
    for(int i = 0; i < 1100; i++){
      x = static_cast<exfloat>( d );
      memory_dump(reinterpret_cast<unsigned char*>(&d));
      cout << i << setiosflags(ios::scientific) << ' ' << d << ' ' << x << endl;
      d /= 2;
    }

    float s = 0.1;
    x = static_cast<exfloat>(s);
    cout << setprecision(20) << x << endl;

    s = 0.01;
    x = static_cast<exfloat>(s);
    cout << setprecision(20) << x << endl;

    d = 0.1;
    x = static_cast<exfloat>(d);
    cout << setprecision(20) << x << endl;

    d = 0.01;
    x = static_cast<exfloat>(d);
    cout << setprecision(20) << x << endl;

#endif

    unsigned long long e[] = { 0, 0x8000000000000000ULL, 0xffffffffffffffffULL, 0x7fffffffffffffffULL };

    exfloat x = 1;
    exfloat y = 1;

    for(int i = 0; i < 4; i++){
	for(int j = 0; j < 4; j++){

	    x.num[0] = e[i];
	    y.num[0] = e[j];

	    exfloat z = x * y;
	    cout << x << " * " << y << " = " << z << endl;
	}
    }

    return 0;
}

// End of file
